// Delegates Demonstration by Stoyan Iordanov

using System;

namespace DelegatesDemo
{
	public delegate void MyDelegate(int i);

	class DelegateUser
	{
		//     ,       
		public static void AddNumbers(MyDelegate toCall)
		{
			Console.Write("Enter first number: ");
			int firstNumber = int.Parse(Console.ReadLine());

			Console.Write("Enter second number: ");
			int secondNumber = int.Parse(Console.ReadLine());

			toCall(firstNumber + secondNumber);
		}

		//   42   
		public static void Pass42(MyDelegate toCall)
		{
			toCall(42);
		}
	}

	class Ball
	{
		private int diameter = 1;

		public void SetDiameter(int newDiameter)
		{
			diameter = newDiameter;
		}

		public override string ToString()
		{
			return String.Format("Ball with diameter {0}", diameter);
		}
	}

	class MainClass
	{
		private static void ShowNumber(int i)
		{
			Console.WriteLine("MainClass.ShowNumber: {0}", i);
		}

		static void Main(string[] args)
		{
			MyDelegate d = new MyDelegate(ShowNumber);
			DelegateUser.AddNumbers(d);

			Ball redBall = new Ball();
			d += new MyDelegate(redBall.SetDiameter);
			//  
			// d = (MyDelegate)Delegate.Combine(d, new MyDelegate(redBall.SetDiameter));

			Console.WriteLine(redBall);
			DelegateUser.Pass42(d);
			Console.WriteLine(redBall);

			d -= new MyDelegate(redBall.SetDiameter);
			//  
			// d = (MyDelegate)Delegate.Remove(d, new MyDelegate(redBall.SetDiameter));
			d(3);
			Console.WriteLine(redBall);
		}
	}
}
